<?php
// $Id: swu_import.admin.inc, v1.0 2011/12/04 $
/**
 * @file
 * Administration forms of swu_import module.
 */
require_once 'includes/PHPExcel.php';
module_load_include('inc', 'swu_import');
drupal_add_css(drupal_get_path('module', 'swu_import') .'/swu_import.css');

/**
 * Admin settings form.
 */
	function swu_import_settings_form() {
		$form = array();

		$form['swu_import_download_type'] = array(
			'#type' => 'radios',
			'#title' => t('Choose import method'),
			'#options' => array(
				'full' => t("Full method"),
				'quick' => t("Quick method"), 
	    		),
			'#default_value' => variable_get('swu_import:method', 'quick'),
	    );
		$form['swu_import_path'] = array(
			'#type' => 'textfield',
			'#title' => t("Choose temporary directory"),
			'#default_value' => variable_get('swu_import:path', 'sites/default/files/swuimport'),
		);
		$form['swu_import_admin_submit'] = array(
			'#type' => 'submit',
			'#value' => t("Save"),
		);
		return $form;
	}
	function swu_import_settings_form_validate($form, &$form_state){
		$path = $form['swu_import_path']['#post']['swu_import_path'];
		$method = $form['swu_import_download_type']['#post']['swu_import_download_type'];
		if ($r = opendir($path)){
			variable_set('swu_import:path', $path);
			variable_set('swu_import:method', $method);
			closedir($r);
			drupal_set_message('Settings accepted');
		}
	}
	function swu_import_upload_form(){
		$form = array();

		$form['#attributes'] = array(
			'class' => 'swu-admin-form',
			'enctype' => "multipart/form-data",
		);
		$form['upload'] = array(
			'#type' => 'fieldset',
			'#title' => t('Upload file'),
			'#description' => t('<strong>The file you are uploading must be in UTF8 encoding.</strong>'),
			'#collapsible' => TRUE,
			'#collapsed' => FALSE,
		);
		$form['upload']['file_upload'] = array(
			'#type' => 'file',
			'#size' => 60,
		);
		$form['upload']['file_upload_button'] = array(
			'#type' => 'submit',
			'#value' => t('Upload file'),
			'#validate' => array('swu_import_upload_form_validate'),
			'#submit' => array('swu_import_upload_form_submit'),
		);
		$form['export'] = array(
			'#type' => 'fieldset',
			'#title' => t('Export'),
			'#description' => '',
			'#collapsible' => TRUE,
			'#collapsed' => FALSE,
		);
		$form['export']['export_button'] = array(
			'#type' => 'submit',
			'#value' => t('Export'),
			'#validate' => array('swu_import_upload_form_validate'),
			'#submit' => array('swu_import_upload_form_submit'),
		);

		return $form;
	}
	function swu_import_upload_form_validate($form, &$form_state){
		$op = $form_state['values']['op'];

		if ($op == t('Upload file')){
			$validators = array(
				'file_validate_extensions' => array('xls'),
				'file_validate_size' => array(524288000)
			);
			
			$dest = variable_get('swu_import:path', 'sites/default/files/swuimport');

			if (($file = file_save_upload('file_upload', $validators, $dest, FILE_EXISTS_RENAME))) {
				file_set_status($file, FILE_STATUS_PERMANENT);
				drupal_set_message(t('Файл %name загружен', array('%name' => $file->filename)));
				$form_state['values']['file'] = $file;
			}
			else{form_set_error('file_upload', 'Файл не был загружен');}
		}
		elseif ($op == t('Export')){}
	}
	function swu_import_upload_form_submit($form, &$form_state){
		$op = $form_state['values']['op'];
		
		if ($op == t('Upload file')){
			$file = $form_state['values']['file'];
			$xls = PHPExcel_IOFactory::load($file->filepath);
			$aSheet = $xls->setActiveSheetIndex(0);
			$maxRow = $aSheet->getHighestRow();
			$maxCol = PHPExcel_Cell::columnIndexFromString($aSheet->getHighestColumn());
			$method = variable_get('swu_import:method', 'quick');
			
			if ($maxRow < 1){exit;}

			/*
			 *
			 *  

			 0  - Артикул ($node->model)
			 1  - Модель ($node->field_product_model[0][value])
			 2  - Наименование ($node->title)
			 3  - Краткое наименование ($node->field_product_stitle[0][value])
			 4  - Категория ($node->taxonomy[?][name])
			 5  - Код категории ($node->taxonomy[?][tid])
			 6  - Производитель ($node->field_manufac_name[0][value])
			 7  - Код производителя ($node->field_product_manufac_id[0][value])
			 8  - Цена ($node->sell_price)
			 9  - Наличие ($node->field_product_presense[0][value])
			 10 - Краткое описание ($node->field_product_short[0][value])
			 11 - Описание ($node->content[body][#value])
			 12 - Изображение ($node->field_image_cache[0][filepath])
			 13 - Тип вывода на главной ($node->field_product_front_type[0][value])
			 14 - Акционный текст ($node->field_product_action_text[0][value])
			 15 - Сортировка ($node->field_product_weight[0][value])
			 16 - SEO Title ($node->field_product_seotitle[0][value])
			 17 - SEO Description ($node->nodewords[metatags][description][value])
			 18 - Значение1 ($node->field_prop_value[0][value])
			 19 - Значение2 ($node->field_prop_value[1][value])
			 20 - Значение3 ($node->field_prop_value[2][value])
			 21 - Значение4 ($node->field_prop_value[3][value])
			 22 - Значение5 ($node->field_prop_value[4][value])
			 23 - Значение6 ($node->field_prop_value[5][value])
			 24 - Значение7 ($node->field_prop_value[6][value])
			 25 - Значение8 ($node->field_prop_value[7][value])
			 26 - Значение9 ($node->field_prop_value[8][value])
			 27 - Значение10 ($node->field_prop_value[9][value])

			 
			 * 
			 * 
			 */

			 if ($method == 'quick'){
				$opers = array();
				for($r=2; $r<=$maxRow; $r++){
					$values = array(
						$aSheet->getCellByColumnAndRow(0, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(1, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(3, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(8, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(9, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(13, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(14, $r)->getValue()
					);
					$opers[] = array('swu_import_import_quick', array($values, $maxRow-1));
				}
				$batch = array(
					'operations' => $opers,
					'title' => t('Importing...'),
					'init_message' => t('Starting the import...'),
					'progress_message' => t('Importing @current out of @total'),
					'error_message' => t('An error occurred and some or all of the exports have failed.'),
					'finished' => 'swu_import_batch_finished',
					'file' => drupal_get_path('module', 'swu_import') . '/swu_import.admin.inc',
				);
				batch_set($batch);
			}
			elseif ($method == 'full'){
				$opers = array();
				for($r=2; $r<=$maxRow; $r++){
					$values = array(
						$aSheet->getCellByColumnAndRow(0, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(1, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(2, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(3, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(4, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(5, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(6, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(7, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(8, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(9, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(10, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(11, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(12, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(13, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(14, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(15, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(16, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(17, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(18, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(19, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(20, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(21, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(22, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(23, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(24, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(25, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(26, $r)->getValue(),
						$aSheet->getCellByColumnAndRow(27, $r)->getValue()
					);
					$opers[] = array('swu_import_import_full', array($values, $maxRow-1));
				}
				$batch = array(
					'operations' => $opers,
					'title' => t('Importing...'),
					'init_message' => t('Starting the import...'),
					'progress_message' => t('Importing @current out of @total'),
					'error_message' => t('An error occurred and some or all of the exports have failed.'),
					'finished' => 'swu_import_batch_finished',
					'file' => drupal_get_path('module', 'swu_import') . '/swu_import.admin.inc',
				);
				batch_set($batch);
			}
		}
		elseif ($op == t('Export')){
			$xls = new PHPExcel();
			$xls->setActiveSheetIndex(0);
			$aSheet = $xls->getActiveSheet();
			$aSheet->setTitle('1');
			
			$cols = array('A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'AA', 'AB', 'AC', 'AD');
			
			$aSheet->setCellValue('A1', 'Артикул');
			$aSheet->setCellValue('B1', 'Модель');
			$aSheet->setCellValue('C1', 'Наименование');
			$aSheet->setCellValue('D1', 'Наименование Кратко');
			$aSheet->setCellValue('E1', 'Категория');
			$aSheet->setCellValue('F1', 'Код категории');
			$aSheet->setCellValue('G1', 'Производитель');
			$aSheet->setCellValue('H1', 'Код производителя');
			$aSheet->setCellValue('I1', 'Цена');
			$aSheet->setCellValue('J1', 'Наличие');
			$aSheet->setCellValue('K1', 'Краткое описание');
			$aSheet->setCellValue('L1', 'Описание');
			$aSheet->setCellValue('M1', 'Изображение');
			$aSheet->setCellValue('N1', 'Тип вывода на главной');
			$aSheet->setCellValue('O1', 'Акционный текст');
			$aSheet->setCellValue('P1', 'Сортировка');
			$aSheet->setCellValue('Q1', 'SEO Title');
			$aSheet->setCellValue('R1', 'SEO Description');
			$aSheet->setCellValue('S1', 'Параметр1');
			$aSheet->setCellValue('T1', 'Параметр2');
			$aSheet->setCellValue('U1', 'Параметр3');
			$aSheet->setCellValue('V1', 'Параметр4');
			$aSheet->setCellValue('W1', 'Параметр5');
			$aSheet->setCellValue('X1', 'Параметр6');
			$aSheet->setCellValue('Y1', 'Параметр7');
			$aSheet->setCellValue('Z1', 'Параметр8');
			$aSheet->setCellValue('AA1', 'Параметр9');
			$aSheet->setCellValue('AB1', 'Параметр10');
			$aSheet->setCellValue('AC1', 'nid');
			$aSheet->setCellValue('AD1', 'URL');
			
			$q = db_query('
				SELECT * FROM {node}
					LEFT JOIN {uc_products} ON {node}.nid = {uc_products}.nid
					LEFT JOIN {content_type_product} ON {node}.nid = {content_type_product}.nid
					LEFT JOIN {nodewords} ON {node}.nid = {nodewords}.id
					LEFT JOIN {node_revisions} ON {node}.nid = {node_revisions}.nid
				WHERE
					{node}.type = "product" AND {nodewords}.name = "description";
			');
			$idx = 1;
			while($row = db_fetch_object($q)){
				$idx++;

				$q1 = db_query("SELECT * FROM {term_node} LEFT JOIN {term_data} ON {term_node}.tid = {term_data}.tid WHERE {term_node}.nid = $row->nid;");
				$r1 = db_fetch_object($q1);
				
				$q2 = db_query("SELECT * FROM {content_field_prop_value} WHERE {content_field_prop_value}.nid = $row->nid;");
				$params = array('', '', '', '', '', '', '', '', '', '');
				while($r2 = db_fetch_object($q2)){$params[$r2->delta] = $r2->field_prop_value_value;}
				
				$q3 = db_query("SELECT * FROM {content_field_image_cache} LEFT JOIN {files} ON {content_field_image_cache}.field_image_cache_fid = {files}.fid  WHERE {content_field_image_cache}.nid = $row->nid;");
				$r3 = db_fetch_object($q3);

				$aSheet->setCellValue('A'.$idx, $row->model);
				$aSheet->setCellValue('B'.$idx, $row->field_product_model_value);
				$aSheet->setCellValue('C'.$idx, $row->title);
				$aSheet->setCellValue('D'.$idx, $row->field_product_stitle_value);
				$aSheet->setCellValue('E'.$idx, $r1->name);
				$aSheet->setCellValue('F'.$idx, $r1->tid);
				$aSheet->setCellValue('G'.$idx, $row->field_manufac_name_value);
				$aSheet->setCellValue('H'.$idx, $row->field_product_manufac_id_value);
				$aSheet->setCellValue('I'.$idx, $row->sell_price);
				$aSheet->setCellValue('J'.$idx, $row->field_product_presense_value);
				$aSheet->setCellValue('K'.$idx, $row->field_product_short_value);
				$aSheet->setCellValue('L'.$idx, $row->body);
				$aSheet->setCellValue('M'.$idx, file_create_url($r3->filepath));
				$aSheet->setCellValue('N'.$idx, $row->field_product_front_type_value);
				$aSheet->setCellValue('O'.$idx, $row->field_product_action_text_value);
				$aSheet->setCellValue('P'.$idx, $row->field_product_weight_value);
				$aSheet->setCellValue('Q'.$idx, $row->field_product_seotitle_value);
				$aSheet->setCellValue('R'.$idx, unserialize($row->content));
				$aSheet->setCellValue('S'.$idx, $params[0]);
				$aSheet->setCellValue('T'.$idx, $params[1]);
				$aSheet->setCellValue('U'.$idx, $params[2]);
				$aSheet->setCellValue('V'.$idx, $params[3]);
				$aSheet->setCellValue('W'.$idx, $params[4]);
				$aSheet->setCellValue('X'.$idx, $params[5]);
				$aSheet->setCellValue('Y'.$idx, $params[6]);
				$aSheet->setCellValue('Z'.$idx, $params[7]);
				$aSheet->setCellValue('AA'.$idx, $params[8]);
				$aSheet->setCellValue('AB'.$idx, $params[9]);
				$aSheet->setCellValue('AC'.$idx, $row->nid);
				$aSheet->setCellValue('AD'.$idx, 'http://'.$_SERVER['HTTP_HOST'].'/'.drupal_get_path_alias('node/'.$row->nid));
			}
			
			header('Content-Type: application/vnd.ms-excel');
			header('Content-Disposition: attachment;filename="price.xls"');
			header('Cache-Control: max-age=0');

			$objWriter = PHPExcel_IOFactory::createWriter($xls, 'Excel5');
			$objWriter->save('php://output');
		}
	}
	
	function swu_import_import_quick($values, $rows, &$context){
		if (!isset($context['sandbox']['progress'])){
			$context['sandbox']['progress'] = 0;
			$context['sandbox']['max'] = $rows;
		}
		$q = db_query('SELECT * FROM {uc_products} WHERE model = "'.$values[0].'"');
		while($row = db_fetch_object($q)){
			$node = node_load($row->nid);
			$context['message'] = t('Processing %title...', array('%title' => $node->title));
			$node->field_product_model[0]['value'] = $values[1];
			$node->field_product_stitle[0]['value'] = $values[2];
			$node->sell_price = $values[3];
			$node->field_product_presense[0]['value'] = $values[4];
			$node->field_product_front_type[0]['value'] = $values[5];
			$node->field_product_action_text[0]['value'] = $values[6];
			node_save($node);
			$context['sandbox']['progress']++;
		}
		if ($context['sandbox']['progress'] != $context['sandbox']['max']) {
			$context['finished'] = $context['sandbox']['progress'] / $context['sandbox']['max'];
		}
	}
	function swu_import_import_full($values, $rows, &$context){
		if (!isset($context['sandbox']['progress'])){
			$context['sandbox']['progress'] = 0;
			$context['sandbox']['max'] = $rows;
		}
		$q = db_query('SELECT * FROM {uc_products} WHERE model = "'.$values[0].'"');
		if ($row = db_fetch_object($q)){
			$title = $values[2];
			$seo_title = $values[16];

			$node = node_load($row->nid);
			$context['message'] = t('Processing %title...', array('%title' => $node->title));

			$node->model = $values[0];
			$node->field_product_model[0]['value'] = $values[1];
			$node->title = $title;
			$node->field_product_stitle[0]['value'] = $values[3];

			$q2 = db_query('SELECT * FROM {term_data} WHERE name = "'.$values[4].'"');
			while($row2 = db_fetch_object($q2)){
				$term = (object)array('vid' => 1, 'tid' => $row2->tid, 'name' => $row2->name, 'description' => $row2->description, 'weight' => $row2->weight);
				$node->taxonomy[$row2->tid] = $term;
				$node->field_product_category_code[0]['value'] = $row2->tid;
			}

			$node->field_manufac_name[0]['value'] = $values[6];
			$node->field_product_manufac_id[0]['value'] = $values[7];
			$node->sell_price = $values[8];
			$node->field_product_presense[0]['value'] = $values[9];
			$node->field_product_short[0]['value'] = $values[10];
			$node->body = $values[11];

			if ($values[12]){
				error_reporting(E_ERROR);
				$path_parts = pathinfo($values[12]);
				if ($handle = fopen($values[12], "rb")){
					$contents = '';
					while (!feof($handle)){$contents .= fread($handle, 8192);}
					fclose($handle);
					file_save_data($contents, 'sites/default/files/'.$path_parts['basename'], FILE_EXISTS_RENAME);
					$node->field_image_cache[0] = field_file_save_file('sites/default/files/'.$path_parts['basename'], array(), 'sites/default/files/');
				}
				error_reporting(E_ALL);
			}

			$node->field_product_front_type[0]['value'] = $values[13];
			$node->field_product_action_text[0]['value'] = $values[14];
			$node->field_product_weight[0]['value'] = $values[15];
			$node->field_product_seotitle[0]['value'] = ($seo_title != '') ? $seo_title : $title;
			$node->nodewords['metatags']['description']['value'] = $values[17];

			$node->field_prop_value[0]['value'] = $values[18];
			$node->field_prop_value[1]['value'] = $values[19];
			$node->field_prop_value[2]['value'] = $values[20];
			$node->field_prop_value[3]['value'] = $values[21];
			$node->field_prop_value[4]['value'] = $values[22];
			$node->field_prop_value[5]['value'] = $values[23];
			$node->field_prop_value[6]['value'] = $values[24];
			$node->field_prop_value[7]['value'] = $values[25];
			$node->field_prop_value[8]['value'] = $values[26];
			$node->field_prop_value[9]['value'] = $values[27];

			node_save($node);
			$context['sandbox']['progress']++;
			$context['message'] = t('Processing %title', array('%title' => $node->title));
		}
		else{
			$title = $values[2];
			$seo_title = $values[16];

			$node = new stdClass();
			$node->type = "product";
			$node->language = 'ru';
			$node->uid = 1;
			$node->model = $values[0];
			$node->field_product_model[0]['value'] = $values[1];
			$node->title = $title;
			$node->field_product_stitle[0]['value'] = $values[3];

			$q3 = db_query('SELECT * FROM {term_data} WHERE name = "'.$values[4].'"');
			while($row3 = db_fetch_object($q3)){
				$term = (object)array('vid' => 1, 'tid' => $row3->tid, 'name' => $row3->name, 'description' => $row3->description, 'weight' => $row3->weight);
				$node->taxonomy[$row3->tid] = $term;
				$node->field_product_category_code[0]['value'] = $row3->tid;
			}

			$node->field_manufac_name[0]['value'] = $values[6];
			$node->field_product_manufac_id[0]['value'] = $values[7];
			$node->sell_price = $values[8];
			$node->field_product_presense[0]['value'] = $values[9];
			$node->field_product_short[0]['value'] = $values[10];
			$node->body = $values[11];

			if ($values[12]){
				error_reporting(E_ERROR);
				$path_parts = pathinfo($values[12]);
				if ($handle = fopen($values[12], "rb")){
					$contents = '';
					while (!feof($handle)){$contents .= fread($handle, 8192);}
					fclose($handle);
					file_save_data($contents, 'sites/default/files/'.$path_parts['basename'], FILE_EXISTS_RENAME);
					$node->field_image_cache[0] = field_file_save_file('sites/default/files/'.$path_parts['basename'], array(), 'sites/default/files/');
				}
				error_reporting(E_ALL);
			}

			$node->field_product_front_type[0]['value'] = $values[13];
			$node->field_product_action_text[0]['value'] = $values[14];
			$node->field_product_weight[0]['value'] = $values[15];
			$node->field_product_seotitle[0]['value'] = ($seo_title != '') ? $seo_title : $title;
			$node->nodewords['metatags']['description']['value'] = $values[17];

			$node->field_prop_value[0]['value'] = $values[18];
			$node->field_prop_value[1]['value'] = $values[19];
			$node->field_prop_value[2]['value'] = $values[20];
			$node->field_prop_value[3]['value'] = $values[21];
			$node->field_prop_value[4]['value'] = $values[22];
			$node->field_prop_value[5]['value'] = $values[23];
			$node->field_prop_value[6]['value'] = $values[24];
			$node->field_prop_value[7]['value'] = $values[25];
			$node->field_prop_value[8]['value'] = $values[26];
			$node->field_prop_value[9]['value'] = $values[27];

			node_save($node);
			$context['sandbox']['progress']++;
			$context['message'] = t('Processing %title', array('%title' => $node->title));
		}

		if ($context['sandbox']['progress'] != $context['sandbox']['max']) {
			$context['finished'] = $context['sandbox']['progress'] / $context['sandbox']['max'];
		}
	}
	function swu_import_batch_finished($success, $results, $operations){
		if ($success){
			drupal_set_message('Импорт завершен!');
		}
		else{
			drupal_set_message('Завершено с ошибками.', 'error');
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	